<script setup lang="ts">
import EntityLineWithImg from "@/components/organisms/list/EntityLineWithImg.vue";
import Flex from "@/components/atoms/container/Flex.vue";
import {PreparedVersion} from "@/entities/Repository/PreparedVersion";
import SelectButton from "primevue/selectbutton";
import {computed, watch} from "vue";
import Grid from "@/components/atoms/container/Grid.vue";
import BranchVersioningInputs
  from "@/components/organisms/list/Repository/RepositoryNewVersionLine/inputs/BranchVersioningInputs.vue";
import NewVersionVersioningInputs
  from "@/components/organisms/list/Repository/RepositoryNewVersionLine/inputs/NewVersionVersioningInputs.vue";
import TagVersioningInputs
  from "@/components/organisms/list/Repository/RepositoryNewVersionLine/inputs/ExistingVersionVersioningInputs.vue";
import {useUpdateTypeEnumStore} from "@/stores/Enum/UpdateTypeEnumStore";

const props = defineProps<{
  preparedVersion: PreparedVersion
}>()

const repository = computed(() => props.preparedVersion.repository);

const updateTypeEnumStore = useUpdateTypeEnumStore();

watch(() => props.preparedVersion, () => console.log(props.preparedVersion))
</script>

<template>
  <EntityLineWithImg
      v-if="preparedVersion && repository"
      :alt="repository.name"
      :img="repository.img"
  >
    <Flex class="flex-col gap-text grow p-1">
      <Grid class="gap-text items-center grid-cols-5">
        <Flex class="gap-text col-span-3">
          <span>{{ repository.name }}</span>
          <span>(Version actuelle : {{ repository.latestVersionFormattedCode }})</span>
        </Flex>
        <Flex class="col-span-2">
          <SelectButton
              v-model="preparedVersion.updateType"
              modelValue="id"
              dataKey="id"
              :options="updateTypeEnumStore.updateTypes"
              optionLabel="shortLabel"
              :invalid="!preparedVersion.updateType"
              :allowEmpty="false"
          />
        </Flex>
      </Grid>
      <Flex class="gap-text items-center">
        <NewVersionVersioningInputs
            :preparedVersion="preparedVersion"
            v-if="preparedVersion.updateType.id === 'NEW_VERSION'"
        />
        <TagVersioningInputs
            :preparedVersion="preparedVersion"
            v-else-if="preparedVersion.updateType.id === 'EXISTING_VERSION'"
        />
        <BranchVersioningInputs
            :preparedVersion="preparedVersion"
            v-else-if="preparedVersion.updateType.id === 'BRANCH'"
        />
      </Flex>
    </Flex>
  </EntityLineWithImg>
</template>